<h1>Список пользователей</h1>
<input type="button" value="Добавить" class="btn btn-light" (click)="add()" />
<h3>Всего в таблице элементов {{userCount}}</h3>
<table *ngIf="tableMode; else create" class="table table-striped">
    <thead>
        <tr>
            <td>Id</td>
            <td>Имя</td>
            <td>Фамилия</td>
            <td>Дата рождения</td>
        </tr>
    </thead>
    <tbody>
        <tr *ngFor="let i of users">
            <ng-template [ngIf]="user?.id != i.id" [ngIfElse]="edit">
                <td width="20%">{{i?.id}}</td>
                <td width="20%">{{i?.name}}</td>
                <td width="20%">{{i?.surname}}</td>
                <td width="20%">{{i?.dateOfBirth}}</td>
                <td width="20%">
                    <button class="btn btn-sm btn-primary" (click)="editUser(i)">Изменить</button>
                    <button class="btn btn-sm btn-danger" (click)="deleteUser(i)">Удалить</button>
                </td>
            </ng-template>
        </tr>
    </tbody>
</table>
<ngb-pagination *ngIf="tableMode" class="d-flex justify-content-center" [collectionSize]="userCount" [pageSize]="pageSize" [(page)]="page" [boundaryLinks]="true" (pageChange)="onPageChanged($event)"></ngb-pagination>


<!--шаблон для редактирования-->
<ng-template #edit>
    <td>
        <input type="text" disabled [ngModel]="user.id" class="form-control" />
    </td>
    <td>
        <input #name="ngModel" required pattern="^^[A-Z]+(([',. -][a-zA-Z ])?[a-zA-Z]*)*$" type="text" [(ngModel)]="user.name" class="form-control" />
        <div class="alert alert-danger" [hidden]="name.valid || name.pristine">
            Имя должно начинаться с большой буквы и состоять только из латинских букв
        </div>
    </td>
    <td>
        <input #surname="ngModel" required pattern="^^[A-Z]+(([',. -][a-zA-Z ])?[a-zA-Z]*)*$" type="text" [(ngModel)]="user.surname" class="form-control" />
        <div class="alert alert-danger" [hidden]="surname.valid || surname.pristine">
            Фамилия должна начинаться с большой буквы и состоять только из латинских букв
        </div>    
    </td>
    <td>
        <input #dateOfBirth="ngModel" required pattern="([12]\d{3}-(0[1-9]|1[0-2])-(0[1-9]|[12]\d|3[01]))" type="text" [(ngModel)]="user.dateOfBirth" class="form-control" />
        <div class="alert alert-danger" [hidden]="dateOfBirth.valid || dateOfBirth.pristine">
            Дата должна быть в формате yyyy-mm-dd
        </div>   
    </td>
    <td width="20%">
        <input type="button" [disabled]="!name.valid || !surname.valid || !dateOfBirth.valid" value="Сохранить" (click)="updateUser()" class="btn btn-sm btn-success" />
        <input type="button" value="Отмена" (click)="cancelEditUser()" class="btn btn-sm btn-warning" />
    </td>
</ng-template>

<!--шаблон для добавления-->
<ng-template #create>
    <div class="form-group">
        <label>Имя</label>
        <input #name="ngModel" required pattern="^^[A-Z]+(([',. -][a-zA-Z ])?[a-zA-Z]*)*$" type="text" [(ngModel)]="user.name" class="form-control" />
        <div class="alert alert-danger" [hidden]="name.valid || name.pristine">
            Имя должно начинаться с большой буквы и состоять только из латинских букв
        </div>
    </div>
    <div class="form-group">
        <label>Фамилия</label>
        <input #surname="ngModel" required pattern="^^[A-Z]+(([',. -][a-zA-Z ])?[a-zA-Z]*)*$" type="text" [(ngModel)]="user.surname" class="form-control" />
        <div class="alert alert-danger" [hidden]="surname.valid || surname.pristine">
            Фамилия должна начинаться с большой буквы и состоять только из латинских букв
        </div>
    </div>
    <div class="form-group">
        <label>Дата Рождения</label>
        <input #dateOfBirth="ngModel" required pattern="([12]\d{3}-(0[1-9]|1[0-2])-(0[1-9]|[12]\d|3[01]))" type="text" [(ngModel)]="user.dateOfBirth" class="form-control" />
        <div class="alert alert-danger" [hidden]="dateOfBirth.valid || dateOfBirth.pristine">
            Дата должна быть в формате yyyy-mm-dd
        </div>
    </div>
    <div>
        <input type="button" [disabled]="!dateOfBirth.valid || !surname.valid || !name.valid" value="Сохранить" (click)="createUser()" class="btn btn-success" />
        <input type="button" value="Отмена" (click)="cancelAddUser()" class="btn btn-warning" />
    </div>
</ng-template>